SDL_haptic.h File Reference

The SDL haptic subsystem allows you to control haptic (force feedback) devices. More...

`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_joystick.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_haptic.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_HapticDirection
| Structure that represents a haptic direction. More...
struct | SDL_HapticConstant
| A structure containing a template for a Constant effect. More...
struct | SDL_HapticPeriodic
| A structure containing a template for a Periodic effect. More...
struct | SDL_HapticCondition
| A structure containing a template for a Condition effect. More...
struct | SDL_HapticRamp
| A structure containing a template for a Ramp effect. More...
struct | SDL_HapticLeftRight
| A structure containing a template for a Left/Right effect. More...
struct | SDL_HapticCustom
| A structure containing a template for the SDL_HAPTIC_CUSTOM effect. More...
union | SDL_HapticEffect
| The generic template for any haptic effect. More...

## Macros

Haptic effects
#define | SDL_HAPTIC_CONSTANT (1u<<0)
| Constant effect supported. More...
#define | SDL_HAPTIC_SINE (1u<<1)
| Sine wave effect supported. More...
#define | SDL_HAPTIC_LEFTRIGHT (1u<<2)
| Left/Right effect supported. More...
#define | SDL_HAPTIC_TRIANGLE (1u<<3)
| Triangle wave effect supported. More...
#define | SDL_HAPTIC_SAWTOOTHUP (1u<<4)
| Sawtoothup wave effect supported. More...
#define | SDL_HAPTIC_SAWTOOTHDOWN (1u<<5)
| Sawtoothdown wave effect supported. More...
#define | SDL_HAPTIC_RAMP (1u<<6)
| Ramp effect supported. More...
#define | SDL_HAPTIC_SPRING (1u<<7)
| Spring effect supported - uses axes position. More...
#define | SDL_HAPTIC_DAMPER (1u<<8)
| Damper effect supported - uses axes velocity. More...
#define | SDL_HAPTIC_INERTIA (1u<<9)
| Inertia effect supported - uses axes acceleration. More...
#define | SDL_HAPTIC_FRICTION (1u<<10)
| Friction effect supported - uses axes movement. More...
#define | SDL_HAPTIC_CUSTOM (1u<<11)
| Custom effect is supported. More...
#define | SDL_HAPTIC_GAIN (1u<<12)
| Device can set global gain. More...
#define | SDL_HAPTIC_AUTOCENTER (1u<<13)
| Device can set autocenter. More...
#define | SDL_HAPTIC_STATUS (1u<<14)
| Device can be queried for effect status. More...
#define | SDL_HAPTIC_PAUSE (1u<<15)
| Device can be paused. More...

## Direction encodings

#define | SDL_HAPTIC_POLAR 0
| Uses polar coordinates for the direction. More...
#define | SDL_HAPTIC_CARTESIAN 1
| Uses cartesian coordinates for the direction. More...
#define | SDL_HAPTIC_SPHERICAL 2
| Uses spherical coordinates for the direction. More...
#define | SDL_HAPTIC_INFINITY 4294967295U
| Used to play a device an infinite number of times. More...
int | SDL_NumHaptics (void)
| Count the number of haptic devices attached to the system. More...
const char * | SDL_HapticName (int device_index)
| Get the implementation dependent name of a haptic device. More...
SDL_Haptic * | SDL_HapticOpen (int device_index)
| Opens a haptic device for use. More...
int | SDL_HapticOpened (int device_index)
| Checks if the haptic device at index has been opened. More...
int | SDL_HapticIndex (SDL_Haptic *haptic)
| Gets the index of a haptic device. More...
int | SDL_MouseIsHaptic (void)
| Gets whether or not the current mouse has haptic capabilities. More...
SDL_Haptic * | SDL_HapticOpenFromMouse (void)
| Tries to open a haptic device from the current mouse. More...
int | SDL_JoystickIsHaptic (SDL_Joystick *joystick)
| Checks to see if a joystick has haptic features. More...
SDL_Haptic * | SDL_HapticOpenFromJoystick (SDL_Joystick *joystick)
| Opens a haptic device for use from a joystick device. More...
void | SDL_HapticClose (SDL_Haptic *haptic)
| Closes a haptic device previously opened with SDL_HapticOpen(). More...
int | SDL_HapticNumEffects (SDL_Haptic *haptic)
| Returns the number of effects a haptic device can store. More...
int | SDL_HapticNumEffectsPlaying (SDL_Haptic *haptic)
| Returns the number of effects a haptic device can play at the same time. More...
unsigned int | SDL_HapticQuery (SDL_Haptic *haptic)
| Gets the haptic device's supported features in bitwise manner. More...
int | SDL_HapticNumAxes (SDL_Haptic *haptic)
| Gets the number of haptic axes the device has. More...
int | SDL_HapticEffectSupported (SDL_Haptic *haptic, SDL_HapticEffect *effect)
| Checks to see if effect is supported by haptic. More...
int | SDL_HapticNewEffect (SDL_Haptic *haptic, SDL_HapticEffect *effect)
| Creates a new haptic effect on the device. More...
int | SDL_HapticUpdateEffect (SDL_Haptic *haptic, int effect, SDL_HapticEffect *data)
| Updates the properties of an effect. More...
int | SDL_HapticRunEffect (SDL_Haptic *haptic, int effect, Uint32 iterations)
| Runs the haptic effect on its associated haptic device. More...
int | SDL_HapticStopEffect (SDL_Haptic *haptic, int effect)
| Stops the haptic effect on its associated haptic device. More...
void | SDL_HapticDestroyEffect (SDL_Haptic *haptic, int effect)
| Destroys a haptic effect on the device. More...
int | SDL_HapticGetEffectStatus (SDL_Haptic *haptic, int effect)
| Gets the status of the current effect on the haptic device. More...
int | SDL_HapticSetGain (SDL_Haptic *haptic, int gain)
| Sets the global gain of the device. More...
int | SDL_HapticSetAutocenter (SDL_Haptic *haptic, int autocenter)
| Sets the global autocenter of the device. More...
int | SDL_HapticPause (SDL_Haptic *haptic)
| Pauses a haptic device. More...
int | SDL_HapticUnpause (SDL_Haptic *haptic)
| Unpauses a haptic device. More...
int | SDL_HapticStopAll (SDL_Haptic *haptic)
| Stops all the currently playing effects on a haptic device. More...
int | SDL_HapticRumbleSupported (SDL_Haptic *haptic)
| Checks to see if rumble is supported on a haptic device. More...
int | SDL_HapticRumbleInit (SDL_Haptic *haptic)
| Initializes the haptic device for simple rumble playback. More...
int | SDL_HapticRumblePlay (SDL_Haptic *haptic, float strength, Uint32 length)
| Runs simple rumble on a haptic device. More...
int | SDL_HapticRumbleStop (SDL_Haptic *haptic)
| Stops the simple rumble on a haptic device. More...

## Detailed Description

The SDL haptic subsystem allows you to control haptic (force feedback) devices.

The basic usage is as follows:

- Initialize the subsystem (SDL_INIT_HAPTIC).
- Open a haptic device.
  - SDL_HapticOpen() to open from index.
  - SDL_HapticOpenFromJoystick() to open from an existing joystick.
- Create an effect (SDL_HapticEffect).
- Upload the effect with SDL_HapticNewEffect().
- Run the effect with SDL_HapticRunEffect().
- (optional) Free the effect with SDL_HapticDestroyEffect().
- Close the haptic device with SDL_HapticClose().

Simple rumble example:
  SDL_Haptic *haptic;
  // Open the device
  haptic = SDL_HapticOpen( 0 );
  if (haptic == NULL)
  return -1;
  // Initialize simple rumble
  if (SDL_HapticRumbleInit( haptic ) != 0)
  return -1;
  // Play effect at 50% strength for 2 seconds
  if (SDL_HapticRumblePlay( haptic, 0.5, 2000 ) != 0)
  return -1;
  SDL_Delay( 2000 );
  // Clean up
  SDL_HapticClose( haptic );

Complete example:
  int test_haptic( SDL_Joystick * joystick ) {
  SDL_Haptic *haptic;
  SDL_HapticEffect effect;
  int effect_id;
  // Open the device
  haptic = SDL_HapticOpenFromJoystick( joystick );
  if (haptic == NULL) return -1; // Most likely joystick isn't haptic
  // See if it can do sine waves
  if ((SDL_HapticQuery(haptic) & SDL_HAPTIC_SINE)==0) {
  SDL_HapticClose(haptic); // No sine effect
  return -1;
  }
  // Create the effect
  memset( &effect, 0, sizeof(SDL_HapticEffect) ); // 0 is safe default
  effect.type = SDL_HAPTIC_SINE;
  effect.periodic.direction.type = SDL_HAPTIC_POLAR; // Polar coordinates
  effect.periodic.direction.dir[0] = 18000; // Force comes from south
  effect.periodic.period = 1000; // 1000 ms
  effect.periodic.magnitude = 20000; // 20000/32767 strength
  effect.periodic.length = 5000; // 5 seconds long
  effect.periodic.attack_length = 1000; // Takes 1 second to get max strength
  effect.periodic.fade_length = 1000; // Takes 1 second to fade away
  // Upload the effect
  effect_id = SDL_HapticNewEffect( haptic, &effect );
  // Test the effect
  SDL_HapticRunEffect( haptic, effect_id, 1 );
  SDL_Delay( 5000); // Wait for the effect to finish
  // We destroy the effect, although closing the device also does this
  SDL_HapticDestroyEffect( haptic, effect_id );
  // Close the device
  SDL_HapticClose(haptic);
  return 0; // Success
  }

Definition in file SDL_haptic.h.

## Macro Definition Documentation

## SDL_HAPTIC_AUTOCENTER

#define SDL_HAPTIC_AUTOCENTER (1u<<13)

Device can set autocenter.

Device supports setting autocenter.

See also
  SDL_HapticSetAutocenter

Definition at line 291 of file SDL_haptic.h.

## SDL_HAPTIC_CARTESIAN

#define SDL_HAPTIC_CARTESIAN 1

Uses cartesian coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 330 of file SDL_haptic.h.

## SDL_HAPTIC_CONSTANT

#define SDL_HAPTIC_CONSTANT (1u<<0)

Constant effect supported.

Constant haptic effect.

See also
  SDL_HapticCondition

Definition at line 163 of file SDL_haptic.h.

## SDL_HAPTIC_CUSTOM

#define SDL_HAPTIC_CUSTOM (1u<<11)

Custom effect is supported.

User defined custom haptic effect.

Definition at line 269 of file SDL_haptic.h.

## SDL_HAPTIC_DAMPER

#define SDL_HAPTIC_DAMPER (1u<<8)

Damper effect supported - uses axes velocity.

Condition haptic effect that simulates dampening. Effect is based on the axes velocity.

See also
  SDL_HapticCondition

Definition at line 242 of file SDL_haptic.h.

## SDL_HAPTIC_FRICTION

#define SDL_HAPTIC_FRICTION (1u<<10)

Friction effect supported - uses axes movement.

Condition haptic effect that simulates friction. Effect is based on the axes movement.

See also
  SDL_HapticCondition

Definition at line 262 of file SDL_haptic.h.

## SDL_HAPTIC_GAIN

#define SDL_HAPTIC_GAIN (1u<<12)

Device can set global gain.

Device supports setting the global gain.

See also
  SDL_HapticSetGain

Definition at line 282 of file SDL_haptic.h.

## SDL_HAPTIC_INERTIA

#define SDL_HAPTIC_INERTIA (1u<<9)

Inertia effect supported - uses axes acceleration.

Condition haptic effect that simulates inertia. Effect is based on the axes acceleration.

See also
  SDL_HapticCondition

Definition at line 252 of file SDL_haptic.h.

## SDL_HAPTIC_INFINITY

#define SDL_HAPTIC_INFINITY 4294967295U

Used to play a device an infinite number of times.

See also
  SDL_HapticRunEffect

Definition at line 352 of file SDL_haptic.h.

## SDL_HAPTIC_LEFTRIGHT

#define SDL_HAPTIC_LEFTRIGHT (1u<<2)

Left/Right effect supported.

Haptic effect for direct control over high/low frequency motors.

See also
  SDL_HapticLeftRight

Warning
  this value was SDL_HAPTIC_SQUARE right before 2.0.0 shipped. Sorry, we ran out of bits, and this is important for XInput devices.

Definition at line 183 of file SDL_haptic.h.

## SDL_HAPTIC_PAUSE

#define SDL_HAPTIC_PAUSE (1u<<15)

Device can be paused.

Devices supports being paused.

See also
  SDL_HapticPause
  SDL_HapticUnpause

Definition at line 310 of file SDL_haptic.h.

## SDL_HAPTIC_POLAR

#define SDL_HAPTIC_POLAR 0

Uses polar coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 323 of file SDL_haptic.h.

## SDL_HAPTIC_RAMP

#define SDL_HAPTIC_RAMP (1u<<6)

Ramp effect supported.

Ramp haptic effect.

See also
  SDL_HapticRamp

Definition at line 222 of file SDL_haptic.h.

## SDL_HAPTIC_SAWTOOTHDOWN

#define SDL_HAPTIC_SAWTOOTHDOWN (1u<<5)

Sawtoothdown wave effect supported.

Periodic haptic effect that simulates saw tooth down waves.

See also
  SDL_HapticPeriodic

Definition at line 213 of file SDL_haptic.h.

## SDL_HAPTIC_SAWTOOTHUP

#define SDL_HAPTIC_SAWTOOTHUP (1u<<4)

Sawtoothup wave effect supported.

Periodic haptic effect that simulates saw tooth up waves.

See also
  SDL_HapticPeriodic

Definition at line 204 of file SDL_haptic.h.

## SDL_HAPTIC_SINE

#define SDL_HAPTIC_SINE (1u<<1)

Sine wave effect supported.

Periodic haptic effect that simulates sine waves.

See also
  SDL_HapticPeriodic

Definition at line 172 of file SDL_haptic.h.

## SDL_HAPTIC_SPHERICAL

#define SDL_HAPTIC_SPHERICAL 2

Uses spherical coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 337 of file SDL_haptic.h.

## SDL_HAPTIC_SPRING

#define SDL_HAPTIC_SPRING (1u<<7)

Spring effect supported - uses axes position.

Condition haptic effect that simulates a spring. Effect is based on the axes position.

See also
  SDL_HapticCondition

Definition at line 232 of file SDL_haptic.h.

## SDL_HAPTIC_STATUS

#define SDL_HAPTIC_STATUS (1u<<14)

Device can be queried for effect status.

Device supports querying effect status.

See also
  SDL_HapticGetEffectStatus

Definition at line 300 of file SDL_haptic.h.

## SDL_HAPTIC_TRIANGLE

#define SDL_HAPTIC_TRIANGLE (1u<<3)

Triangle wave effect supported.

Periodic haptic effect that simulates triangular waves.

See also
  SDL_HapticPeriodic

Definition at line 195 of file SDL_haptic.h.

## Function Documentation

## SDL_HapticClose()

void SDL_HapticClose | ( | SDL_Haptic * | haptic | ) |

Closes a haptic device previously opened with SDL_HapticOpen().

Parameters

  haptic | Haptic device to close.

Definition at line 339 of file SDL_haptic.c.

{
int i;
SDL_Haptic *hapticlist;
SDL_Haptic *hapticlistprev;
/* Must be valid */
if (!ValidHaptic(haptic)) {
return;
}
/* Check if it's still in use */
if (--haptic->ref_count > 0) {
return;
}
/* Close it, properly removing effects if needed */
for (i = 0; i < haptic->neffects; i++) {
if (haptic->effects[i].hweffect != NULL) {
SDL_HapticDestroyEffect(haptic, i);
}
}
SDL_SYS_HapticClose(haptic);
/* Remove from the list */
hapticlist = SDL_haptics;
hapticlistprev = NULL;
while ( hapticlist )
{
if (haptic == hapticlist)
{
if ( hapticlistprev )
{
/* unlink this entry */
hapticlistprev->next = hapticlist->next;
}
else
{
SDL_haptics = haptic->next;
}
break;
}
hapticlistprev = hapticlist;
hapticlist = hapticlist->next;
}
/* Free */
SDL_free(haptic);
}

References haptic, i, NULL, SDL_free, SDL_HapticDestroyEffect(), SDL_haptics, SDL_SYS_HapticClose(), and ValidHaptic().

Referenced by SDL_HapticQuit().

## SDL_HapticDestroyEffect()

void SDL_HapticDestroyEffect | ( | SDL_Haptic * | haptic,
|  | int | effect
| ) |  |

Destroys a haptic effect on the device.

This will stop the effect if it's running. Effects are automatically destroyed when the device is closed.

Parameters

  haptic | Device to destroy the effect on.
  effect | Identifier of the effect to destroy.

See also
  SDL_HapticNewEffect

Definition at line 592 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic) || !ValidEffect(haptic, effect)) {
return;
}
/* Not allocated */
if (haptic->effects[effect].hweffect == NULL) {
return;
}
SDL_SYS_HapticDestroyEffect(haptic, &haptic->effects[effect]);
}

References haptic, NULL, SDL_SYS_HapticDestroyEffect(), ValidEffect(), and ValidHaptic().

Referenced by SDL_HapticClose().

## SDL_HapticEffectSupported()

int SDL_HapticEffectSupported | ( | SDL_Haptic * | haptic,
|  | SDL_HapticEffect * | effect
| ) |  |

Checks to see if effect is supported by haptic.

Parameters

  haptic | Haptic device to check on.
  effect | Effect to check to see if it is supported.

Returns
  SDL_TRUE if effect is supported, SDL_FALSE if it isn't or -1 on error.

See also
  SDL_HapticQuery
  SDL_HapticNewEffect

Definition at line 462 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
if ((haptic->supported & effect->type) != 0)
return SDL_TRUE;
return SDL_FALSE;
}

References haptic, SDL_FALSE, SDL_TRUE, SDL_HapticEffect::type, and ValidHaptic().

Referenced by SDL_HapticNewEffect().

## SDL_HapticGetEffectStatus()

int SDL_HapticGetEffectStatus | ( | SDL_Haptic * | haptic,
|  | int | effect
| ) |  |

Gets the status of the current effect on the haptic device.

Device must support the SDL_HAPTIC_STATUS feature.

Parameters

  haptic | Haptic device to query the effect status on.
  effect | Identifier of the effect to query its status.

Returns
  0 if it isn't playing, 1 if it is playing or -1 on error.

See also
  SDL_HapticRunEffect
  SDL_HapticStopEffect

Definition at line 610 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic) || !ValidEffect(haptic, effect)) {
return -1;
}
if ((haptic->supported & SDL_HAPTIC_STATUS) == 0) {
return SDL_SetError("Haptic: Device does not support status queries.");
}
return SDL_SYS_HapticGetEffectStatus(haptic, &haptic->effects[effect]);
}

References haptic, SDL_HAPTIC_STATUS, SDL_SetError, SDL_SYS_HapticGetEffectStatus(), ValidEffect(), and ValidHaptic().

## SDL_HapticIndex()

int SDL_HapticIndex | ( | SDL_Haptic * | haptic | ) |

Gets the index of a haptic device.

Parameters

  haptic | Haptic device to get the index of.

Returns
  The index of the haptic device or -1 on error.

See also
  SDL_HapticOpen
  SDL_HapticOpened

Definition at line 204 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
return haptic->index;
}

References haptic, and ValidHaptic().

## SDL_HapticName()

const char* SDL_HapticName | ( | int | device_index | ) |

Get the implementation dependent name of a haptic device.

This can be called before any joysticks are opened. If no name can be found, this function returns NULL.

Parameters

  device_index | Index of the device to get its name.

Returns
  Name of the device or NULL on error.

See also
  SDL_NumHaptics

Definition at line 97 of file SDL_haptic.c.

{
if ((device_index < 0) || (device_index >= SDL_NumHaptics())) {
SDL_SetError("Haptic: There are %d haptic devices available",
SDL_NumHaptics());
return NULL;
}
return SDL_SYS_HapticName(device_index);
}

References NULL, SDL_NumHaptics(), SDL_SetError, and SDL_SYS_HapticName().

## SDL_HapticNewEffect()

int SDL_HapticNewEffect | ( | SDL_Haptic * | haptic,
|  | SDL_HapticEffect * | effect
| ) |  |

Creates a new haptic effect on the device.

Parameters

  haptic | Haptic device to create the effect on.
  effect | Properties of the effect to create.

Returns
  The identifier of the effect on success or -1 on error.

See also
  SDL_HapticUpdateEffect
  SDL_HapticRunEffect
  SDL_HapticDestroyEffect

Definition at line 477 of file SDL_haptic.c.

{
int i;
/* Check for device validity. */
if (!ValidHaptic(haptic)) {
return -1;
}
/* Check to see if effect is supported */
if (SDL_HapticEffectSupported(haptic, effect) == SDL_FALSE) {
return SDL_SetError("Haptic: Effect not supported by haptic device.");
}
/* See if there's a free slot */
for (i = 0; i < haptic->neffects; i++) {
if (haptic->effects[i].hweffect == NULL) {
/* Now let the backend create the real effect */
if (SDL_SYS_HapticNewEffect(haptic, &haptic->effects[i], effect)
!= 0) {
return -1; /* Backend failed to create effect */
}
SDL_memcpy(&haptic->effects[i].effect, effect,
sizeof(SDL_HapticEffect));
return i;
}
}
return SDL_SetError("Haptic: Device has no free space left.");
}

References haptic, i, NULL, SDL_FALSE, SDL_HapticEffectSupported(), SDL_memcpy, SDL_SetError, SDL_SYS_HapticNewEffect(), and ValidHaptic().

Referenced by SDL_HapticRumbleInit().

## SDL_HapticNumAxes()

int SDL_HapticNumAxes | ( | SDL_Haptic * | haptic | ) |

Gets the number of haptic axes the device has.

See also
  SDL_HapticDirection

Definition at line 449 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
return haptic->naxes;
}

References haptic, and ValidHaptic().

## SDL_HapticNumEffects()

int SDL_HapticNumEffects | ( | SDL_Haptic * | haptic | ) |

Returns the number of effects a haptic device can store.

On some platforms this isn't fully supported, and therefore is an approximation. Always check to see if your created effect was actually created and do not rely solely on SDL_HapticNumEffects().

Parameters

  haptic | The haptic device to query effect max.

Returns
  The number of effects the haptic device can store or -1 on error.

See also
  SDL_HapticNumEffectsPlaying
  SDL_HapticQuery

Definition at line 407 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
return haptic->neffects;
}

References haptic, and ValidHaptic().

## SDL_HapticNumEffectsPlaying()

int SDL_HapticNumEffectsPlaying | ( | SDL_Haptic * | haptic | ) |

Returns the number of effects a haptic device can play at the same time.

This is not supported on all platforms, but will always return a value. Added here for the sake of completeness.

Parameters

  haptic | The haptic device to query maximum playing effects.

Returns
  The number of effects the haptic device can play at the same time or -1 on error.

See also
  SDL_HapticNumEffects
  SDL_HapticQuery

Definition at line 421 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
return haptic->nplaying;
}

References haptic, and ValidHaptic().

## SDL_HapticOpen()

SDL_Haptic* SDL_HapticOpen | ( | int | device_index | ) |

Opens a haptic device for use.

The index passed as an argument refers to the N'th haptic device on this system.

When opening a haptic device, its gain will be set to maximum and autocenter will be disabled. To modify these values use SDL_HapticSetGain() and SDL_HapticSetAutocenter().

Parameters

  device_index | Index of the device to open.

Returns
  Device identifier or NULL on error.

See also
  SDL_HapticIndex
  SDL_HapticOpenFromMouse
  SDL_HapticOpenFromJoystick
  SDL_HapticClose
  SDL_HapticSetGain
  SDL_HapticSetAutocenter
  SDL_HapticPause
  SDL_HapticStopAll

Definition at line 112 of file SDL_haptic.c.

{
SDL_Haptic *haptic;
SDL_Haptic *hapticlist;
if ((device_index < 0) || (device_index >= SDL_NumHaptics())) {
SDL_SetError("Haptic: There are %d haptic devices available",
SDL_NumHaptics());
return NULL;
}
hapticlist = SDL_haptics;
/* If the haptic is already open, return it
* TODO: Should we create haptic instance IDs like the Joystick API?
*/
while ( hapticlist )
{
if (device_index == hapticlist->index) {
haptic = hapticlist;
++haptic->ref_count;
return haptic;
}
hapticlist = hapticlist->next;
}
/* Create the haptic device */
haptic = (SDL_Haptic *) SDL_malloc((sizeof *haptic));
if (haptic == NULL) {
SDL_OutOfMemory();
return NULL;
}
/* Initialize the haptic device */
SDL_memset(haptic, 0, (sizeof *haptic));
haptic->rumble_id = -1;
haptic->index = device_index;
if (SDL_SYS_HapticOpen(haptic) < 0) {
SDL_free(haptic);
return NULL;
}
/* Add haptic to list */
++haptic->ref_count;
/* Link the haptic in the list */
haptic->next = SDL_haptics;
SDL_haptics = haptic;
/* Disable autocenter and set gain to max. */
if (haptic->supported & SDL_HAPTIC_GAIN)
SDL_HapticSetGain(haptic, 100);
if (haptic->supported & SDL_HAPTIC_AUTOCENTER)
SDL_HapticSetAutocenter(haptic, 0);
return haptic;
}

References haptic, NULL, SDL_free, SDL_HAPTIC_AUTOCENTER, SDL_HAPTIC_GAIN, SDL_haptics, SDL_HapticSetAutocenter(), SDL_HapticSetGain(), SDL_malloc, SDL_memset, SDL_NumHaptics(), SDL_OutOfMemory, SDL_SetError, and SDL_SYS_HapticOpen().

Referenced by SDL_HapticOpenFromMouse().

## SDL_HapticOpened()

int SDL_HapticOpened | ( | int | device_index | ) |

Checks if the haptic device at index has been opened.

Parameters

  device_index | Index to check to see if it has been opened.

Returns
  1 if it has been opened or 0 if it hasn't.

See also
  SDL_HapticOpen
  SDL_HapticIndex

Definition at line 173 of file SDL_haptic.c.

{
int opened;
SDL_Haptic *hapticlist;
/* Make sure it's valid. */
if ((device_index < 0) || (device_index >= SDL_NumHaptics())) {
SDL_SetError("Haptic: There are %d haptic devices available",
SDL_NumHaptics());
return 0;
}
opened = 0;
hapticlist = SDL_haptics;
/* TODO Should this use an instance ID? */
while ( hapticlist )
{
if (hapticlist->index == (Uint8) device_index) {
opened = 1;
break;
}
hapticlist = hapticlist->next;
}
return opened;
}

References SDL_haptics, SDL_NumHaptics(), and SDL_SetError.

## SDL_HapticOpenFromJoystick()

SDL_Haptic* SDL_HapticOpenFromJoystick | ( | SDL_Joystick * | joystick | ) |

Opens a haptic device for use from a joystick device.

You must still close the haptic device separately. It will not be closed with the joystick.

When opening from a joystick you should first close the haptic device before closing the joystick device. If not, on some implementations the haptic device will also get unallocated and you'll be unable to use force feedback on that device.

Parameters

  joystick | Joystick to create a haptic device from.

Returns
  A valid haptic device identifier on success or NULL on error.

See also
  SDL_HapticOpen
  SDL_HapticClose

Definition at line 273 of file SDL_haptic.c.

{
SDL_Haptic *haptic;
SDL_Haptic *hapticlist;
/* Make sure there is room. */
if (SDL_NumHaptics() <= 0) {
SDL_SetError("Haptic: There are %d haptic devices available",
SDL_NumHaptics());
return NULL;
}
/* Must be a valid joystick */
if (!SDL_PrivateJoystickValid(joystick)) {
SDL_SetError("Haptic: Joystick isn't valid.");
return NULL;
}
/* Joystick must be haptic */
if (SDL_SYS_JoystickIsHaptic(joystick) <= 0) {
SDL_SetError("Haptic: Joystick isn't a haptic device.");
return NULL;
}
hapticlist = SDL_haptics;
/* Check to see if joystick's haptic is already open */
while ( hapticlist )
{
if (SDL_SYS_JoystickSameHaptic(hapticlist, joystick)) {
haptic = hapticlist;
++haptic->ref_count;
return haptic;
}
hapticlist = hapticlist->next;
}
/* Create the haptic device */
haptic = (SDL_Haptic *) SDL_malloc((sizeof *haptic));
if (haptic == NULL) {
SDL_OutOfMemory();
return NULL;
}
/* Initialize the haptic device */
SDL_memset(haptic, 0, sizeof(SDL_Haptic));
haptic->rumble_id = -1;
if (SDL_SYS_HapticOpenFromJoystick(haptic, joystick) < 0) {
SDL_SetError("Haptic: SDL_SYS_HapticOpenFromJoystick failed.");
SDL_free(haptic);
return NULL;
}
/* Add haptic to list */
++haptic->ref_count;
/* Link the haptic in the list */
haptic->next = SDL_haptics;
SDL_haptics = haptic;
return haptic;
}

References haptic, NULL, SDL_free, SDL_haptics, SDL_malloc, SDL_memset, SDL_NumHaptics(), SDL_OutOfMemory, SDL_PrivateJoystickValid(), SDL_SetError, SDL_SYS_HapticOpenFromJoystick(), SDL_SYS_JoystickIsHaptic(), and SDL_SYS_JoystickSameHaptic().

## SDL_HapticOpenFromMouse()

SDL_Haptic* SDL_HapticOpenFromMouse | ( | void |  | ) |

Tries to open a haptic device from the current mouse.

Returns
  The haptic device identifier or NULL on error.

See also
  SDL_MouseIsHaptic
  SDL_HapticOpen

Definition at line 230 of file SDL_haptic.c.

{
int device_index;
device_index = SDL_SYS_HapticMouse();
if (device_index < 0) {
SDL_SetError("Haptic: Mouse isn't a haptic device.");
return NULL;
}
return SDL_HapticOpen(device_index);
}

References NULL, SDL_HapticOpen(), SDL_SetError, and SDL_SYS_HapticMouse().

## SDL_HapticPause()

int SDL_HapticPause | ( | SDL_Haptic * | haptic | ) |

Pauses a haptic device.

Device must support the SDL_HAPTIC_PAUSE feature. Call SDL_HapticUnpause() to resume playback.

Do not modify the effects nor add new ones while the device is paused. That can cause all sorts of weird errors.

Parameters

  haptic | Haptic device to pause.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticUnpause

Definition at line 697 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
if ((haptic->supported & SDL_HAPTIC_PAUSE) == 0) {
return SDL_SetError("Haptic: Device does not support setting pausing.");
}
return SDL_SYS_HapticPause(haptic);
}

References haptic, SDL_HAPTIC_PAUSE, SDL_SetError, SDL_SYS_HapticPause(), and ValidHaptic().

## SDL_HapticQuery()

unsigned int SDL_HapticQuery | ( | SDL_Haptic * | haptic | ) |

Gets the haptic device's supported features in bitwise manner.

Example:

if (SDL_HapticQuery(haptic) & SDL_HAPTIC_CONSTANT) {
printf("We have constant haptic effect!\n");
}

Parameters

  haptic | The haptic device to query.

Returns
  Haptic features in bitwise manner (OR'd).

See also
  SDL_HapticNumEffects
  SDL_HapticEffectSupported

Definition at line 435 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return 0; /* same as if no effects were supported */
}
return haptic->supported;
}

References haptic, and ValidHaptic().

## SDL_HapticRumbleInit()

int SDL_HapticRumbleInit | ( | SDL_Haptic * | haptic | ) |

Initializes the haptic device for simple rumble playback.

Parameters

  haptic | Haptic device to initialize for simple rumble playback.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticOpen
  SDL_HapticRumbleSupported
  SDL_HapticRumblePlay
  SDL_HapticRumbleStop

Definition at line 758 of file SDL_haptic.c.

{
SDL_HapticEffect *efx = &haptic->rumble_effect;
if (!ValidHaptic(haptic)) {
return -1;
}
/* Already allocated. */
if (haptic->rumble_id >= 0) {
return 0;
}
SDL_zerop(efx);
if (haptic->supported & SDL_HAPTIC_SINE) {
efx->type = SDL_HAPTIC_SINE;
efx->periodic.direction.type = SDL_HAPTIC_CARTESIAN;
efx->periodic.period = 1000;
efx->periodic.magnitude = 0x4000;
efx->periodic.length = 5000;
efx->periodic.attack_length = 0;
efx->periodic.fade_length = 0;
} else if (haptic->supported & SDL_HAPTIC_LEFTRIGHT) { /* XInput? */
efx->type = SDL_HAPTIC_LEFTRIGHT;
efx->leftright.length = 5000;
efx->leftright.large_magnitude = 0x4000;
efx->leftright.small_magnitude = 0x4000;
} else {
return SDL_SetError("Device doesn't support rumble");
}
haptic->rumble_id = SDL_HapticNewEffect(haptic, &haptic->rumble_effect);
if (haptic->rumble_id >= 0) {
return 0;
}
return -1;
}

References SDL_HapticPeriodic::attack_length, SDL_HapticPeriodic::direction, SDL_HapticPeriodic::fade_length, haptic, SDL_HapticLeftRight::large_magnitude, SDL_HapticEffect::leftright, SDL_HapticPeriodic::length, SDL_HapticLeftRight::length, SDL_HapticPeriodic::magnitude, SDL_HapticPeriodic::period, SDL_HapticEffect::periodic, SDL_HAPTIC_CARTESIAN, SDL_HAPTIC_LEFTRIGHT, SDL_HAPTIC_SINE, SDL_HapticNewEffect(), SDL_SetError, SDL_zerop, SDL_HapticLeftRight::small_magnitude, SDL_HapticDirection::type, SDL_HapticEffect::type, and ValidHaptic().

## SDL_HapticRumblePlay()

int SDL_HapticRumblePlay | ( | SDL_Haptic * | haptic,
|  | float | strength,
|  | Uint32 | length
| ) |  |

Runs simple rumble on a haptic device.

Parameters

  haptic | Haptic device to play rumble effect on.
  strength | Strength of the rumble to play as a 0-1 float value.
  length | Length of the rumble to play in milliseconds.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticRumbleSupported
  SDL_HapticRumbleInit
  SDL_HapticRumbleStop

Definition at line 800 of file SDL_haptic.c.

{
SDL_HapticEffect *efx;
Sint16 magnitude;
if (!ValidHaptic(haptic)) {
return -1;
}
if (haptic->rumble_id < 0) {
return SDL_SetError("Haptic: Rumble effect not initialized on haptic device");
}
/* Clamp strength. */
if (strength > 1.0f) {
strength = 1.0f;
} else if (strength < 0.0f) {
strength = 0.0f;
}
magnitude = (Sint16)(32767.0f*strength);
efx = &haptic->rumble_effect;
if (efx->type == SDL_HAPTIC_SINE) {
efx->periodic.magnitude = magnitude;
efx->periodic.length = length;
} else if (efx->type == SDL_HAPTIC_LEFTRIGHT) {
efx->leftright.small_magnitude = efx->leftright.large_magnitude = magnitude;
efx->leftright.length = length;
} else {
SDL_assert(0 && "This should have been caught elsewhere");
}
if (SDL_HapticUpdateEffect(haptic, haptic->rumble_id, &haptic->rumble_effect) < 0) {
return -1;
}
return SDL_HapticRunEffect(haptic, haptic->rumble_id, 1);
}

References haptic, SDL_HapticLeftRight::large_magnitude, SDL_HapticEffect::leftright, SDL_HapticPeriodic::length, SDL_HapticLeftRight::length, SDL_HapticPeriodic::magnitude, SDL_HapticEffect::periodic, SDL_assert, SDL_HAPTIC_LEFTRIGHT, SDL_HAPTIC_SINE, SDL_HapticRunEffect(), SDL_HapticUpdateEffect(), SDL_SetError, SDL_HapticLeftRight::small_magnitude, SDL_HapticEffect::type, and ValidHaptic().

## SDL_HapticRumbleStop()

int SDL_HapticRumbleStop | ( | SDL_Haptic * | haptic | ) |

Stops the simple rumble on a haptic device.

Parameters

  haptic | Haptic to stop the rumble on.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticRumbleSupported
  SDL_HapticRumbleInit
  SDL_HapticRumblePlay

Definition at line 843 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
if (haptic->rumble_id < 0) {
return SDL_SetError("Haptic: Rumble effect not initialized on haptic device");
}
return SDL_HapticStopEffect(haptic, haptic->rumble_id);
}

References haptic, SDL_HapticStopEffect(), SDL_SetError, and ValidHaptic().

## SDL_HapticRumbleSupported()

int SDL_HapticRumbleSupported | ( | SDL_Haptic * | haptic | ) |

Checks to see if rumble is supported on a haptic device.

Parameters

  haptic | Haptic device to check to see if it supports rumble.

Returns
  SDL_TRUE if effect is supported, SDL_FALSE if it isn't or -1 on error.

See also
  SDL_HapticRumbleInit
  SDL_HapticRumblePlay
  SDL_HapticRumbleStop

Definition at line 744 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
/* Most things can use SINE, but XInput only has LEFTRIGHT. */
return ((haptic->supported & (SDL_HAPTIC_SINE|SDL_HAPTIC_LEFTRIGHT)) != 0);
}

References haptic, SDL_HAPTIC_LEFTRIGHT, SDL_HAPTIC_SINE, and ValidHaptic().

## SDL_HapticRunEffect()

int SDL_HapticRunEffect | ( | SDL_Haptic * | haptic,
|  | int | effect,
|  | Uint32 | iterations
| ) |  |

Runs the haptic effect on its associated haptic device.

If iterations are SDL_HAPTIC_INFINITY, it'll run the effect over and over repeating the envelope (attack and fade) every time. If you only want the effect to last forever, set SDL_HAPTIC_INFINITY in the effect's length parameter.

Parameters

  haptic | Haptic device to run the effect on.
  effect | Identifier of the haptic effect to run.
  iterations | Number of iterations to run the effect. Use SDL_HAPTIC_INFINITY for infinity.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticStopEffect
  SDL_HapticDestroyEffect
  SDL_HapticGetEffectStatus

Definition at line 555 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic) || !ValidEffect(haptic, effect)) {
return -1;
}
/* Run the effect */
if (SDL_SYS_HapticRunEffect(haptic, &haptic->effects[effect], iterations)
< 0) {
return -1;
}
return 0;
}

References haptic, iterations, SDL_SYS_HapticRunEffect(), ValidEffect(), and ValidHaptic().

Referenced by SDL_HapticRumblePlay().

## SDL_HapticSetAutocenter()

int SDL_HapticSetAutocenter | ( | SDL_Haptic * | haptic,
|  | int | autocenter
| ) |  |

Sets the global autocenter of the device.

Autocenter should be between 0 and 100. Setting it to 0 will disable autocentering.

Device must support the SDL_HAPTIC_AUTOCENTER feature.

Parameters

  haptic | Haptic device to set autocentering on.
  autocenter | Value to set autocenter to, 0 disables autocentering.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticQuery

Definition at line 672 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
if ((haptic->supported & SDL_HAPTIC_AUTOCENTER) == 0) {
return SDL_SetError("Haptic: Device does not support setting autocenter.");
}
if ((autocenter < 0) || (autocenter > 100)) {
return SDL_SetError("Haptic: Autocenter must be between 0 and 100.");
}
if (SDL_SYS_HapticSetAutocenter(haptic, autocenter) < 0) {
return -1;
}
return 0;
}

References haptic, SDL_HAPTIC_AUTOCENTER, SDL_SetError, SDL_SYS_HapticSetAutocenter(), and ValidHaptic().

Referenced by SDL_HapticOpen().

## SDL_HapticSetGain()

int SDL_HapticSetGain | ( | SDL_Haptic * | haptic,
|  | int | gain
| ) |  |

Sets the global gain of the device.

Device must support the SDL_HAPTIC_GAIN feature.

The user may specify the maximum gain by setting the environment variable SDL_HAPTIC_GAIN_MAX which should be between 0 and 100. All calls to SDL_HapticSetGain() will scale linearly using SDL_HAPTIC_GAIN_MAX as the maximum.

Parameters

  haptic | Haptic device to set the gain on.
  gain | Value to set the gain to, should be between 0 and 100.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticQuery

Definition at line 627 of file SDL_haptic.c.

{
const char *env;
int real_gain, max_gain;
if (!ValidHaptic(haptic)) {
return -1;
}
if ((haptic->supported & SDL_HAPTIC_GAIN) == 0) {
return SDL_SetError("Haptic: Device does not support setting gain.");
}
if ((gain < 0) || (gain > 100)) {
return SDL_SetError("Haptic: Gain must be between 0 and 100.");
}
/* We use the envvar to get the maximum gain. */
env = SDL_getenv("SDL_HAPTIC_GAIN_MAX");
if (env != NULL) {
max_gain = SDL_atoi(env);
/* Check for sanity. */
if (max_gain < 0)
max_gain = 0;
else if (max_gain > 100)
max_gain = 100;
/* We'll scale it linearly with SDL_HAPTIC_GAIN_MAX */
real_gain = (gain * max_gain) / 100;
} else {
real_gain = gain;
}
if (SDL_SYS_HapticSetGain(haptic, real_gain) < 0) {
return -1;
}
return 0;
}

References haptic, NULL, SDL_atoi, SDL_getenv, SDL_HAPTIC_GAIN, SDL_SetError, SDL_SYS_HapticSetGain(), and ValidHaptic().

Referenced by SDL_HapticOpen().

## SDL_HapticStopAll()

int SDL_HapticStopAll | ( | SDL_Haptic * | haptic | ) |

Stops all the currently playing effects on a haptic device.

Parameters

  haptic | Haptic device to stop.

Returns
  0 on success or -1 on error.

Definition at line 731 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
return SDL_SYS_HapticStopAll(haptic);
}

References haptic, SDL_SYS_HapticStopAll(), and ValidHaptic().

## SDL_HapticStopEffect()

int SDL_HapticStopEffect | ( | SDL_Haptic * | haptic,
|  | int | effect
| ) |  |

Stops the haptic effect on its associated haptic device.

Parameters

  haptic | Haptic device to stop the effect on.
  effect | Identifier of the effect to stop.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticRunEffect
  SDL_HapticDestroyEffect

Definition at line 574 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic) || !ValidEffect(haptic, effect)) {
return -1;
}
/* Stop the effect */
if (SDL_SYS_HapticStopEffect(haptic, &haptic->effects[effect]) < 0) {
return -1;
}
return 0;
}

References haptic, SDL_SYS_HapticStopEffect(), ValidEffect(), and ValidHaptic().

Referenced by SDL_HapticRumbleStop().

## SDL_HapticUnpause()

int SDL_HapticUnpause | ( | SDL_Haptic * | haptic | ) |

Unpauses a haptic device.

Call to unpause after SDL_HapticPause().

Parameters

  haptic | Haptic device to unpause.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticPause

Definition at line 714 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic)) {
return -1;
}
if ((haptic->supported & SDL_HAPTIC_PAUSE) == 0) {
return 0; /* Not going to be paused, so we pretend it's unpaused. */
}
return SDL_SYS_HapticUnpause(haptic);
}

References haptic, SDL_HAPTIC_PAUSE, SDL_SYS_HapticUnpause(), and ValidHaptic().

## SDL_HapticUpdateEffect()

int SDL_HapticUpdateEffect | ( | SDL_Haptic * | haptic,
|  | int | effect,
|  | SDL_HapticEffect * | data
| ) |  |

Updates the properties of an effect.

Can be used dynamically, although behavior when dynamically changing direction may be strange. Specifically the effect may reupload itself and start playing from the start. You cannot change the type either when running SDL_HapticUpdateEffect().

Parameters

  haptic | Haptic device that has the effect.
  effect | Identifier of the effect to update.
  data | New effect properties to use.

Returns
  0 on success or -1 on error.

See also
  SDL_HapticNewEffect
  SDL_HapticRunEffect
  SDL_HapticDestroyEffect

Definition at line 527 of file SDL_haptic.c.

{
if (!ValidHaptic(haptic) || !ValidEffect(haptic, effect)) {
return -1;
}
/* Can't change type dynamically. */
if (data->type != haptic->effects[effect].effect.type) {
return SDL_SetError("Haptic: Updating effect type is illegal.");
}
/* Updates the effect */
if (SDL_SYS_HapticUpdateEffect(haptic, &haptic->effects[effect], data) <
0) {
return -1;
}
SDL_memcpy(&haptic->effects[effect].effect, data,
sizeof(SDL_HapticEffect));
return 0;
}

References haptic, SDL_memcpy, SDL_SetError, SDL_SYS_HapticUpdateEffect(), ValidEffect(), and ValidHaptic().

Referenced by SDL_HapticRumblePlay().

## SDL_JoystickIsHaptic()

int SDL_JoystickIsHaptic | ( | SDL_Joystick * | joystick | ) |

Checks to see if a joystick has haptic features.

Parameters

  joystick | Joystick to test for haptic capabilities.

Returns
  SDL_TRUE if the joystick is haptic, SDL_FALSE if it isn't or -1 if an error occurred.

See also
  SDL_HapticOpenFromJoystick

Definition at line 249 of file SDL_haptic.c.

{
int ret;
/* Must be a valid joystick */
if (!SDL_PrivateJoystickValid(joystick)) {
return -1;
}
ret = SDL_SYS_JoystickIsHaptic(joystick);
if (ret > 0)
return SDL_TRUE;
else if (ret == 0)
return SDL_FALSE;
else
return -1;
}

References SDL_FALSE, SDL_PrivateJoystickValid(), SDL_SYS_JoystickIsHaptic(), and SDL_TRUE.

## SDL_MouseIsHaptic()

int SDL_MouseIsHaptic | ( | void |  | ) |

Gets whether or not the current mouse has haptic capabilities.

Returns
  SDL_TRUE if the mouse is haptic, SDL_FALSE if it isn't.

See also
  SDL_HapticOpenFromMouse

Definition at line 195 of file SDL_dynapi_procs.h.

References SDL_FALSE, SDL_SYS_HapticMouse(), and SDL_TRUE.

## SDL_NumHaptics()

int SDL_NumHaptics | ( | void |  | ) |

Count the number of haptic devices attached to the system.

Returns
  Number of haptic devices detected on the system.

Definition at line 87 of file SDL_haptic.c.

{
return SDL_SYS_NumHaptics();
}

References SDL_SYS_NumHaptics().

Referenced by SDL_HapticName(), SDL_HapticOpen(), SDL_HapticOpened(), and SDL_HapticOpenFromJoystick().

SDL_HAPTIC_LEFTRIGHT
#define SDL_HAPTIC_LEFTRIGHT
Left/Right effect supported.
Definition: SDL_haptic.h:183
SDL_HapticRumblePlay
#define SDL_HapticRumblePlay
Definition: SDL_dynapi_overrides.h:187
SDL_HapticOpen
SDL_Haptic * SDL_HapticOpen(int device_index)
Opens a haptic device for use.
Definition: SDL_haptic.c:112
SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:386
SDL_HAPTIC_CARTESIAN
#define SDL_HAPTIC_CARTESIAN
Uses cartesian coordinates for the direction.
Definition: SDL_haptic.h:330
SDL_SYS_HapticPause
int SDL_SYS_HapticPause(SDL_Haptic *haptic)
SDL_HapticEffectSupported
int SDL_HapticEffectSupported(SDL_Haptic *haptic, SDL_HapticEffect *effect)
Checks to see if effect is supported by haptic.
Definition: SDL_haptic.c:462
SDL_HapticDirection::dir
Sint32 dir[3]
Definition: SDL_haptic.h:453
SDL_HapticOpenFromJoystick
#define SDL_HapticOpenFromJoystick
Definition: SDL_dynapi_overrides.h:167
SDL_HapticPeriodic::period
Uint16 period
Definition: SDL_haptic.h:566
NULL
#define NULL
Definition: begin_code.h:167
SDL_HapticLeftRight::large_magnitude
Uint16 large_magnitude
Definition: SDL_haptic.h:685
SDL_SYS_HapticName
const char * SDL_SYS_HapticName(int index)
SDL_SYS_HapticUnpause
int SDL_SYS_HapticUnpause(SDL_Haptic *haptic)
SDL_zerop
#define SDL_zerop(x)
Definition: SDL_stdinc.h:417
SDL_HapticOpen
#define SDL_HapticOpen
Definition: SDL_dynapi_overrides.h:161
SDL_HAPTIC_STATUS
#define SDL_HAPTIC_STATUS
Device can be queried for effect status.
Definition: SDL_haptic.h:300
iterations
static int iterations
Definition: testsprite2.c:45
SDL_HapticRunEffect
int SDL_HapticRunEffect(SDL_Haptic *haptic, int effect, Uint32 iterations)
Runs the haptic effect on its associated haptic device.
Definition: SDL_haptic.c:555
SDL_HapticDestroyEffect
void SDL_HapticDestroyEffect(SDL_Haptic *haptic, int effect)
Destroys a haptic effect on the device.
Definition: SDL_haptic.c:592
ValidHaptic
static int ValidHaptic(SDL_Haptic *haptic)
Definition: SDL_haptic.c:56
SDL_SYS_HapticUpdateEffect
int SDL_SYS_HapticUpdateEffect(SDL_Haptic *haptic, struct haptic_effect *effect, SDL_HapticEffect *data)
SDL_HapticEffect::leftright
SDL_HapticLeftRight leftright
Definition: SDL_haptic.h:808
ValidEffect
static int ValidEffect(SDL_Haptic *haptic, int effect)
Definition: SDL_haptic.c:514
SDL_HAPTIC_AUTOCENTER
#define SDL_HAPTIC_AUTOCENTER
Device can set autocenter.
Definition: SDL_haptic.h:291
length
GLuint GLsizei GLsizei * length
Definition: SDL_opengl_glext.h:669
data
GLint GLenum GLsizei GLsizei GLsizei GLint GLsizei const GLvoid * data
Definition: SDL_opengl.h:1974
SDL_SYS_HapticDestroyEffect
void SDL_SYS_HapticDestroyEffect(SDL_Haptic *haptic, struct haptic_effect *effect)
SDL_HapticClose
#define SDL_HapticClose
Definition: SDL_dynapi_overrides.h:168
SDL_HapticLeftRight::length
Uint32 length
Definition: SDL_haptic.h:682
SDL_HapticRunEffect
#define SDL_HapticRunEffect
Definition: SDL_dynapi_overrides.h:176
SDL_SYS_HapticRunEffect
int SDL_SYS_HapticRunEffect(SDL_Haptic *haptic, struct haptic_effect *effect, Uint32 iterations)
SDL_HapticSetAutocenter
int SDL_HapticSetAutocenter(SDL_Haptic *haptic, int autocenter)
Sets the global autocenter of the device.
Definition: SDL_haptic.c:672
SDL_HapticPeriodic::attack_length
Uint16 attack_length
Definition: SDL_haptic.h:572
SDL_HapticPeriodic::magnitude
Sint16 magnitude
Definition: SDL_haptic.h:567
SDL_HapticDestroyEffect
#define SDL_HapticDestroyEffect
Definition: SDL_dynapi_overrides.h:178
Sint16
int16_t Sint16
Definition: SDL_stdinc.h:185
SDL_memcpy
#define SDL_memcpy
Definition: SDL_dynapi_overrides.h:387
SDL_FALSE
@ SDL_FALSE
Definition: SDL_stdinc.h:163
SDL_SYS_HapticSetGain
int SDL_SYS_HapticSetGain(SDL_Haptic *haptic, int gain)
SDL_SYS_HapticGetEffectStatus
int SDL_SYS_HapticGetEffectStatus(SDL_Haptic *haptic, struct haptic_effect *effect)
SDL_HapticEffect::periodic
SDL_HapticPeriodic periodic
Definition: SDL_haptic.h:805
SDL_PrivateJoystickValid
int SDL_PrivateJoystickValid(SDL_Joystick *joystick)
Definition: SDL_joystick.c:394
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
SDL_HapticEffect
The generic template for any haptic effect.
Definition: SDL_haptic.h:800
f
GLfloat f
Definition: SDL_opengl_glext.h:1870
SDL_HapticDirection::type
Uint8 type
Definition: SDL_haptic.h:452
SDL_HAPTIC_SINE
#define SDL_HAPTIC_SINE
Sine wave effect supported.
Definition: SDL_haptic.h:172
SDL_SYS_HapticStopEffect
int SDL_SYS_HapticStopEffect(SDL_Haptic *haptic, struct haptic_effect *effect)
SDL_HapticNewEffect
int SDL_HapticNewEffect(SDL_Haptic *haptic, SDL_HapticEffect *effect)
Creates a new haptic effect on the device.
Definition: SDL_haptic.c:477
SDL_HapticPeriodic::length
Uint32 length
Definition: SDL_haptic.h:558
SDL_haptics
static SDL_Haptic * SDL_haptics
Definition: SDL_haptic.c:32
SDL_SYS_HapticStopAll
int SDL_SYS_HapticStopAll(SDL_Haptic *haptic)
SDL_HapticPeriodic::fade_length
Uint16 fade_length
Definition: SDL_haptic.h:574
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_HapticLeftRight::small_magnitude
Uint16 small_magnitude
Definition: SDL_haptic.h:686
SDL_NumHaptics
int SDL_NumHaptics(void)
Count the number of haptic devices attached to the system.
Definition: SDL_haptic.c:87
SDL_SYS_HapticClose
void SDL_SYS_HapticClose(SDL_Haptic *haptic)
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
SDL_HapticStopEffect
int SDL_HapticStopEffect(SDL_Haptic *haptic, int effect)
Stops the haptic effect on its associated haptic device.
Definition: SDL_haptic.c:574
SDL_OutOfMemory
#define SDL_OutOfMemory()
Definition: SDL_error.h:52
SDL_HAPTIC_GAIN
#define SDL_HAPTIC_GAIN
Device can set global gain.
Definition: SDL_haptic.h:282
SDL_SYS_HapticOpen
int SDL_SYS_HapticOpen(SDL_Haptic *haptic)
SDL_SYS_HapticMouse
int SDL_SYS_HapticMouse(void)
SDL_atoi
#define SDL_atoi
Definition: SDL_dynapi_overrides.h:410
SDL_SYS_HapticNewEffect
int SDL_SYS_HapticNewEffect(SDL_Haptic *haptic, struct haptic_effect *effect, SDL_HapticEffect *base)
haptic
static SDL_Haptic * haptic
Definition: testhaptic.c:25
SDL_getenv
#define SDL_getenv
Definition: SDL_dynapi_overrides.h:378
SDL_TRUE
@ SDL_TRUE
Definition: SDL_stdinc.h:164
memset
#define memset
Definition: SDL_malloc.c:627
SDL_HapticSetGain
int SDL_HapticSetGain(SDL_Haptic *haptic, int gain)
Sets the global gain of the device.
Definition: SDL_haptic.c:627
SDL_HapticUpdateEffect
int SDL_HapticUpdateEffect(SDL_Haptic *haptic, int effect, SDL_HapticEffect *data)
Updates the properties of an effect.
Definition: SDL_haptic.c:527
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_HapticRumbleInit
#define SDL_HapticRumbleInit
Definition: SDL_dynapi_overrides.h:186
SDL_SYS_HapticSetAutocenter
int SDL_SYS_HapticSetAutocenter(SDL_Haptic *haptic, int autocenter)
SDL_HAPTIC_POLAR
#define SDL_HAPTIC_POLAR
Uses polar coordinates for the direction.
Definition: SDL_haptic.h:323
SDL_SYS_NumHaptics
int SDL_SYS_NumHaptics(void)
SDL_SYS_JoystickIsHaptic
int SDL_SYS_JoystickIsHaptic(SDL_Joystick *joystick)
SDL_SYS_JoystickSameHaptic
int SDL_SYS_JoystickSameHaptic(SDL_Haptic *haptic, SDL_Joystick *joystick)
SDL_malloc
#define SDL_malloc
Definition: SDL_dynapi_overrides.h:374
SDL_SYS_HapticOpenFromJoystick
int SDL_SYS_HapticOpenFromJoystick(SDL_Haptic *haptic, SDL_Joystick *joystick)
SDL_HAPTIC_CONSTANT
#define SDL_HAPTIC_CONSTANT
Constant effect supported.
Definition: SDL_haptic.h:163
SDL_HapticPeriodic::direction
SDL_HapticDirection direction
Definition: SDL_haptic.h:555
SDL_HAPTIC_PAUSE
#define SDL_HAPTIC_PAUSE
Device can be paused.
Definition: SDL_haptic.h:310
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_HapticEffect::type
Uint16 type
Definition: SDL_haptic.h:803
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:179
SDL_HapticQuery
#define SDL_HapticQuery
Definition: SDL_dynapi_overrides.h:171
SDL_HapticNewEffect
#define SDL_HapticNewEffect
Definition: SDL_dynapi_overrides.h:174